/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 100; sens <= 6400; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 1.1712241718574182e-06,1.1533879695459355e-06,1.114499083889355e-06,1.1674561363862535e-06 };
    static double noise_model_B[] = { -1.7375440011025078e-05,-1.7768712472412058e-05,-1.4395999566411535e-05,-2.0008757653919925e-05 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 4.30573692612778e-12,3.714703691810916e-12,3.437711336231361e-12,3.595667627575086e-12 };
    static double noise_model_D[] = { 8.36077770033809e-07,7.023333879562925e-07,7.608876911511987e-07,8.266466907064025e-07 };
    double digital_gain = (sens / 1600.0) < 1.0 ? 1.0 : (sens / 1600.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
